/* -*-Mode:C; tab-width:4; indent-tabs-mode:t; c-file-style:"stroustrup";-*- */
// database item (Progect Project entry)
typedef struct {
	UInt16 cardNumber;
	UInt16 lastSentinelValue;
	char databaseName[dmDBNameLength];
	char note[1]; // actually variable size, memory block is extended...
} ProjectListEntry;

struct ProjectListMODELGlobals
{
	DmOpenRef databaseRef;
	UInt16 cardNumber;
	UInt16 refCount;

};

ProjectListEntry *ProjectListMODELGetRecord(UInt16 index);
void ProjectListMODELInit(void);
void ProjectListMODELInitINTERNAL(struct ProjectListMODELGlobals **plGlobals);
void ProjectListMODELCleanUp(void);
void ProjectListMODELCleanupINTERNAL(struct ProjectListMODELGlobals **plGlobals);
void ProjectListMODELClearProjectList(void);
void ProjectListMODELUpdateProjectList(void);
UInt16 ProjectListMODELGetCurrentCategory(void);
void ProjectListMODELSetCurrentCategory(UInt16 currentCategory);
DmOpenRef ProjectListMODELGetDBRef(void);
void ProjListMODELSelectCategory (void);
void ProjectListMODELUpdate(void);
void ProjectListMODELUpdateINTERNAL(struct ProjectListMODELGlobals **plGlobals);
Boolean ProjectListMODELSeekRecord (UInt16 * indexP, Int16 offset, Int16 direction);
Int16 CompareProjectEntryByCardProjectName(void *r1, void *r2,Int16 unused1, SortRecordInfoPtr unused2, SortRecordInfoPtr unused3, MemHandle unused4);
Boolean FindInSortedDatabase(DmOpenRef db, DmComparF *comparFunc, void *findRec, UInt16 *recordNumber);
void ProjectListModelAddProject(UInt16 cardNo, const char *dbName);
void ProjectListModelRenameProject(UInt16 cardNo, const char *dbNameOld,const char *dbNameNew);
void ProjectListModelDeleteProject(UInt16 cardNo, const char *dbName);
UInt16 ProjectListMODELGetRecordCategory(UInt16 record);
void ProjectListMODELSetRecordCategory(UInt16 record,UInt16 newCategory);
UInt16 ProjectListModelGetProjectCategory(UInt16 cardNo, const char *dbName);
void ProjectListModelSetProjectCategory(UInt16 cardNo, const char *dbName, UInt16 newCategory);

